<?php

    /*
    ############################################################################
    #                                                                          #
    # Esselbach Storyteller CMS System                                         #
    #                                                                          #
    # (C) 2002 - 2005 by Esselbach Internet Solutions                          #
    # Available from http://www.esselbach.com                                  #
    #                                                                          #
    # Storyteller CMS System is not free software                              #
    # Visit http://www.esselbach.com/page6.html for the license agreement      #
    #                                                                          #
    ############################################################################
    */

    error_reporting(0);

    if (phpversion() >= "4.1.0")
    {
        $phps = $_SERVER[PHP_SELF];
        $referer = $_SERVER[HTTP_REFERER];
    }
    else
    {
       $phps = getenv("PHP_SELF");
       $referer = getenv("HTTP_REFERER");
    }

    $phps = checkvar ($phps);
    $referer = checkvar ($referer);

    (preg_match("/cadmin/i", $phps)) ? $ext = "../" : $ext = ".";

    if (file_exists("$ext/config.php"))
    {
        require("$ext/config.php");
        $configs = explode(":_:", base64_decode($estc));
    }
    else
    {
        die ("Error: Can't find config.php");
    }

    if (!preg_match("/backend|mobile|downloadget|scode/", $phps))
    {
        if ((phpversion() >= "4.0.5") and (extension_loaded("zlib")) and (!ini_get("output_handler")) and (!ini_get("zlib.output_compression")) and (!$configs[10]))
        {
            ob_start("ob_gzhandler");
        }
    }

    if ((!$configs[11]) and ($ext == "."))
    {
        $statsfile = "cache/stats/stats-".date("m")."-".date("Y").".cgi";

        (!file_exists($statsfile)) ? $fd = fopen($statsfile, "w+") :
         $fd = fopen($statsfile, "r+");

        if (flock($fd, 2))
        {
            $mystats = fgets($fd, 100);
            if (!$mystats) {
                $mystats = 0;
            }
            $mystats++;
            rewind ($fd);
            fwrite ($fd, $mystats);
        }

        flock($fd, 3);
        fclose ($fd);
        @chmod ($statsfile, 0777);
    }

    if (file_exists("$ext/refererconfig.php"))
    {
        require("$ext/refererconfig.php");
    }

    if (($configs[17]) and ($ext == "."))
    {
        foreach ($reflist as $igreferer)
        {
	         $igreferer = str_replace("/","\/",$igreferer);
            if (preg_match("/$igreferer/i", $referer))
            {
                $ireferer = 1;
            }
        }
        if (($referer) and (!$ireferer))
        {
            dbconnect();
            $query = DBQuery("SELECT * FROM esselbach_st_referer WHERE referer_ref = '$referer'");

            if (mysql_num_rows($query))
            {
                DBQuery("UPDATE esselbach_st_referer SET referer_hits=referer_hits+1, referer_date=now() WHERE referer_ref = '$referer'");
            }
            else
            {
                DBQuery("INSERT INTO esselbach_st_referer VALUES (NULL, '$configs[4]', '$referer', now(), '1')");
            }
        }
    }

    if (file_exists("$ext/spiderconfig.php"))
    {
        require("$ext/spiderconfig.php");
        (phpversion() >= "4.1.0") ? $agent = $_SERVER["HTTP_USER_AGENT"] : $agent = getenv("HTTP_USER_AGENT");
        foreach ($spiders as $spider)
        {
            if (preg_match("/$spider/i", $agent))
            {
                echo GetTemplate("$ext/spider");
                exit;
            }
        }
    }

    if (file_exists("bbwrapper.php")) include("bbwrapper.php");

    $eiv = "RXNzZWxiYWNoIFN0b3J5dGVsbGVyIDEuOC0x";

    (phpversion() >= "4.1.0") ? $logcookie = $_COOKIE[esselbachst] : $logcookie = $esselbachst;

    function dbconnect()
    {

        global $configs;

        if ($configs[20])
        {
            @mysql_pconnect($configs[0], $configs[1], $configs[2]) or die ("Error: Can't open a persistent connection to the MySQL database server");
        }
        else
        {
            @mysql_connect($configs[0], $configs[1], $configs[2]) or die ("Error: Can't open a connection to the MySQL database server");
        }
        @mysql_select_db($configs[3]) or die ("Error: Can't select the database");

    }

    function DBQuery ($var)
    {
        global $configs;

        if ($configs[9])
        {
            echo "Query: <b>$var</b> (Time: ".mktime().")<br />";
        }

        $query = mysql_query($var);

        if (!$query)
        {
            echo "Error: <b>".mysql_errno()." <i>".mysql_error()."</i></b>";
            exit;
        }

        return $query;

    }

    function GetTemplate($var)
    {

        if (file_exists("templates/$var.tmp.php"))
        {
            require("templates/$var.tmp.php");
        }
        else
        {
            die ("Error: Can't open template $var");
        }

        return $EST_TEMPLATE;

    }

    function GetCache($var, $var2)
    {

        global $configs;

        if ($configs[18] == "1")
        {

            if (file_exists("cache/$var/$var2.cah.php"))
            {
                require("cache/$var/$var2.cah.php");
                $cache = 1;
            }
            else
            {
                $cache = 0;
            }

        }
        elseif ($configs[18] == "2")
        {
           dbconnect();
           $var2 = $configs[4].$var2;
           if ($var == "downloaddet") $var2 .= "dd";
           $query = DBQuery("SELECT cache_data, cache_expire FROM esselbach_st_cache WHERE cache_page = '$var2' AND cache_category = '$var' AND cache_website = '$configs[4]'");

           if (mysql_num_rows($query))
           {
               list($cache_data, $cache_expire) = mysql_fetch_row($query);
               $cache = 1;
           }
           else
           {
               $cache = 0;
           }
        }
        else
        {
            if (file_exists("cache/$var/$var2.cgi"))
            {
                $cachefile = fopen("cache/$var/$var2.cgi","r");
                $cachedata = fread($cachefile, filesize("cache/$var/$var2.cgi"));
                fclose($cachefile);

                $cachesplit = explode(":;:;:_CACHE_DATA_SPLIT_HERE_:;:;:",$cachedata);
                $cache_expire = $cachesplit[0];
                $cache_data = $cachesplit[1];
                $cache = 1;
            }
            else
            {
                $cache = 0;
            }
        }

        if ($cache_expire)
        {
            if ($cache_expire < mktime())
            {
                $cache = 0;
            }
        }

        if ($cache)
        {
            echo $cache_data;
        }

        return $cache;
    }

    function WriteCache ($var, $var2, $var3, $var4)
    {

        global $configs;

        if ($configs[8])
        {
            if ($configs[18] == "1")
            {
                $var3 = str_replace("$","\$",$var3);
                $cachefile = @fopen("cache/$var/$var2.cah.php", "w") or die ("Error: Can't write $var2 cache");
              	 if (flock($cachefile, 2))
              	 {
                    fputs ($cachefile, "<?php \$cache_expire = \"$var4\";\n\$cache_data = <<<CACHEDPAGEHTML\n$var3\nCACHEDPAGEHTML;\n?>");
         	    }
                flock($cachefile, 3);
                fclose ($cachefile);
                @chmod ("cache/$var/$var2.cah.php", 0777);
            }
            elseif ($configs[18] == "2")
            {
                dbconnect();
                $var3 = addslashes($var3);
                $var2 = $configs[4].$var2;
                if ($var == "downloaddet") $var2 .= "dd";
                DBQuery("DELETE FROM esselbach_st_cache WHERE cache_page = '$var2' AND cache_category = '$var' AND cache_website = '$configs[4]'");
                DBQuery("INSERT INTO esselbach_st_cache VALUES ('$var2','$configs[4]','$var','$var3','$var4')");
                $var3 = stripslashes($var3);
            }
            else
            {
                $cachefile = @fopen("cache/$var/$var2.cgi", "w") or die ("Error: Can't write $var2 cache");
              	 if (flock($cachefile, 2))
              	 {
                    fputs ($cachefile, "$var4:;:;:_CACHE_DATA_SPLIT_HERE_:;:;:$var3");
         	    }
                flock($cachefile, 3);
                fclose ($cachefile);
                @chmod ("cache/$var/$var2.cgi", 0777);
            }
        }
        echo $var3;
    }

    function MiniCache ($var, $var2)
    {

        global $configs;

        $var2 = str_replace("$","\$",$var2);

        if ($configs[8])
        {
            $cachefile = @fopen("$var.cah.php", "w") or die ("Error: Can't write cache");
            if (flock($cachefile, 2))
            {
                fputs ($cachefile, "$var2");
            }
            flock($cachefile, 3);
            fclose ($cachefile);
            @chmod ("$var.cah.php", 0777);
        }
    }

    function DeChomp ($var)
    {
        global $configs;

        if ($configs[19])
        {
            $var = str_replace("<", "&lt;", $var);
            $var = str_replace(">", "&gt;", $var);
        }
        $var = str_replace("\n", "<br />", $var);

        return $var;
    }

    function ReChomp ($var)
    {

        $var = str_replace("<br />", "\n", $var);
        $var = str_replace("&lt;", "<", $var);
        $var = str_replace("&gt;", ">", $var);

        return $var;
    }

    function Icons ($var)
    {
        global $smilie_command_cache, $smilie_image_cache;

        if (!is_array($smilie_command_cache))
        {
            $query = DBQuery("SELECT smilie_command, smilie_image FROM esselbach_st_smilies");
            while (list($command, $image) = mysql_fetch_row($query))
            {
                $smilie_command_cache[] = $command;
                $smilie_image_cache[] = $image;
            }
        }

        for($i = 0; $i < count($smilie_command_cache); $i++)
        {
            $var = str_replace($smilie_command_cache[$i]," <img src=\"$smilie_image_cache[$i]\" border=\"0\">", $var);
        }

        return $var;

    }

    function Code ($var)
    {
        global $code_search_cache, $code_replace_cache, $code_type_cache;

        $var = CheckCode("[quote]","[/quote]",$var);
        $var = CheckCode("[code]","[/code]",$var);
        $var = CheckCode("[b]","[/b]",$var);
        $var = CheckCode("[i]","[/i]",$var);
        $var = CheckCode("[u]","[/u]",$var);
        $var = CheckCode("[marquee]","[/marquee]",$var);
        $var = CheckCode("[s]","[/s]",$var);
        $var = CheckCode("[sup]","[/sup]",$var);
        $var = CheckCode("[sub]","[/sub]",$var);
        $var = CheckCode("[tt]","[/tt]",$var);
        $var = CheckCode("[center]","[/center]",$var);
        $var = CheckCode("[left]","[/left]",$var);
        $var = CheckCode("[right]","[/right]",$var);

        if (!is_array($code_search_cache))
        {
            $query = DBQuery("SELECT code_search, code_replace FROM esselbach_st_blockcodes");
            while (list($search, $replace) = mysql_fetch_row($query))
            {
                $code_search_cache[] = $search;
                $code_replace_cache[] = $replace;
            }
        }

        for($i = 0; $i < count($code_search_cache); $i++)
        {
            $var = str_replace($code_search_cache[$i], $code_replace_cache[$i], $var);
        }

        $var = preg_replace("/\[url\](.*?)\[\/url\]/","<a href=\"\\1\" target=\"_blank\">\\1</a>",$var);
        $var = eregi_replace("\\[img\\]([^\\[]*)\\[/img\\]", "<img src=\"\\1\" border=\"0\">", $var);
        $var = eregi_replace("\\[imgleft\\]([^\\[]*)\\[/imgleft\\]", "<img src=\"\\1\" border=\"0\" align=\"left\" hspace=\"10\" vspace=\"10\">", $var);
        $var = eregi_replace("\\[imgright\\]([^\\[]*)\\[/imgright\\]", "<img src=\"\\1\" border=\"0\" align=\"right\" hspace=\"10\" vspace=\"10\">", $var);
        $var = eregi_replace("\\[email\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\">\\1</a>", $var);
        $var = eregi_replace("\\[url=http://([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"http://\\1\" target=\"_blank\">\\2</a>", $var);
        $var = eregi_replace("\\[url=www.([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"http://www.\\1\" target=\"_blank\">\\2</a>", $var);
        $var = eregi_replace("\\[url=https://([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"https://\\1\" target=\"_blank\">\\2</a>", $var);
        $var = eregi_replace("\\[url=ftp://([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"ftp://\\1\">\\2</a>", $var);
        $var = eregi_replace("\\[url=ftp.([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"ftp://ftp.\\1\">\\2</a>", $var);
        $var = eregi_replace("\\[email=([^\\[]+)\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\">\\2</a>", $var);
        $var = eregi_replace("\\[size=([^\\[]+)\\]([^\\[]*)\\[/size\\]", "<font size=\"\\1\">\\2</font>", $var);
        $var = eregi_replace("\\[font=([^\\[]+)\\]([^\\[]*)\\[/font\\]", "<font face=\"\\1\">\\2</font>", $var);
        $var = eregi_replace("\\[color=([^\\[]+)\\]([^\\[]*)\\[/color\\]", "<font color=\"\\1\">\\2</font>", $var);

        return $var;

    }

    function CheckCode ($var, $var2, $var3)
    {

        $code_open = SuperCount($var,$var3);
        $code_close = SuperCount($var2,$var3);

        if ("$code_open" != "$code_close")
        {
            $var3 = str_replace($var,"",$var3);
            $var3 = str_replace($var2,"",$var3);
        }

        return $var3;
    }

    function FixedRound ($var)
    {
        if (preg_match("/\./i",$var))
        {
            $this_sum = explode(".",$var);
            $this_sum[0]++;
            $var = $this_sum[0];
        }

        return $var;
    }

    function ScriptEx ($var)
    {

        $var = preg_replace("/javascript/i", "java&nbsp;script&nbsp;", $var);
        $var = preg_replace("/vbscript/i", "vb&nbsp;script&nbsp;", $var);
        $var = preg_replace("/about:/i", "about&nbsp;:", $var);
        $var = preg_replace("/JavaScript/i", "Java&nbsp;Script&nbsp;", $var);
        $var = preg_replace("/VBScript/i", "vb&nbsp;script&nbsp;", $var);
        return $var;

    }

    function MakeXML ($var)
    {

        $var = eregi_replace("\\[([^\\[]*)\\]", "", $var);
        return $var;

    }

    function GetDir ($var)
    {

        $dir = array();
        if (file_exists("$var"))
        {
            $od = opendir($var);
            while ($file = readdir($od))
            {
                array_push ($dir, "$file");
            }
            closedir ($od);
            sort($dir);
        }

        return $dir;
    }

    function ClearCache ($var)
    {

        global $ext, $configs;

        if (($configs[18] == "2") and (!preg_match("/pm|stats|tags/i",$var)))
        {
            dbconnect();
            DBQuery("DELETE FROM esselbach_st_cache WHERE cache_category = '$var' AND cache_website = '$configs[4]'");
        }
        else
        {
            $cache_dir = GetDir("$ext/cache/$var");

            for($i = 1; $i < count($cache_dir); $i++)
            {
                if (preg_match("/(.cah.php)/i", $cache_dir[$i]))
                {
                    unlink ("$ext/cache/$var/$cache_dir[$i]");
                }
                if (preg_match("/(.cgi)/i", $cache_dir[$i]))
                {
                    unlink ("$ext/cache/$var/$cache_dir[$i]");
                }
            }
        }
    }

    function ClearImageCache ($var)
    {

        global $ext;

        $cache_dir = GetDir("$ext/images/$var/thumbs");

        for($i = 1; $i < count($cache_dir); $i++)
        {
            if (preg_match("/(.gif|.jpg|.jpeg|.png)/i", $cache_dir[$i]))
            {
                unlink ("$ext/images/$var/thumbs/$cache_dir[$i]");
            }
        }

    }

    function RemoveCache ($var)
    {

        global $ext, $configs;

        if (($configs[18] == "2") and (!preg_match("/pm|stats|tags/i",$var)))
        {
            dbconnect();
            $data = explode("/",$var);
            $data[1] = $configs[4].$data[1];
            if ($data[0] == "downloaddet") $data[1] .= "dd";
            DBQuery("DELETE FROM esselbach_st_cache WHERE cache_page = '$data[1]' AND cache_category = '$data[0]' AND cache_website = '$configs[4]'");
        }
        else
        {
            if (file_exists("$ext/cache/$var.cah.php"))
            {
                unlink ("$ext/cache/$var.cah.php");
            }
            if (file_exists("$ext/cache/$var.cgi"))
            {
                unlink ("$ext/cache/$var.cgi");
            }
        }
    }

    function DoKeywords ($var)
    {

        $words = explode(" ", eregi_replace("\\[([^\\[]*)\\]", "", $var));
        for($i = 0; $i < count($words); $i++)
        {
            if (strlen($words[$i]) > 6) $keywords[] = $words[$i];
        }
        sort($keywords);

        $linewords = 0;
        for ($i = 0; $i < count($keywords); $i++)
        {
            if ((!preg_match("/$keywords[$i]/", $returndata)) and (!preg_match("/^\W|,|\"|\.|\n|<|>|'|²|³|\/|!|\)|\(|:|;/i", $keywords[$i])))
            {
                if ($linewords < 60)
                {
                    $returndata .= $keywords[$i].", ";
                    $linewords++;
                }
            }
        }
        $returndata = substr($returndata, 0, -2);

        return $returndata;

    }

    function checknum ($var)
    {
        $var = intval($var);
        return $var;
    }

    function checkvar ($var)
    {
        if (get_magic_quotes_gpc())
        {
            $var = stripslashes( $var );
        }
        $var = addslashes( utf8_decode( $var ) );
        return $var;
    }

    function istroll ($var)
    {
        $currentdate = date("Y-m-d", mktime());
        $query = DBQuery("SELECT * FROM esselbach_st_autoplonk WHERE plonk_user = '$var' AND plonk_date > ('$currentdate')");
        $var = mysql_num_rows($query);
        return $var;
    }

    function HeaderBlock ()
    {

        global $logcookie, $insert, $configs, $phps, $id, $det;

        if ((preg_match("/story.php/i", $phps)) and ($id))
        {

            if (file_exists("cache/tags/story-$id.cah.php"))
            {
                require("cache/tags/story-$id.cah.php");
            }
            else
            {
                dbconnect();
                $query = DBQuery("SELECT * FROM esselbach_st_stories WHERE story_id = '$id'");
                $data = mysql_fetch_array($query);
                $insert[page_title] = addslashes($data[story_title]);
                $insert[page_keywords] = addslashes(DoKeywords($data[story_text]));
                MiniCache("cache/tags/story-$id", "<?php \$insert[page_title] = \"$insert[page_title]\";\n\$insert[page_keywords] = \"$insert[page_keywords]\"; ?>");
            }
        }

        if ((preg_match("/faqshow.php/i", $phps)) and ($id))
        {

            if (file_exists("cache/tags/faq-$id.cah.php"))
            {
                require("cache/tags/faq-$id.cah.php");
            }
            else
            {
                dbconnect();
                $query = DBQuery("SELECT * FROM esselbach_st_faq WHERE faq_id = '$id'");
                $data = mysql_fetch_array($query);
                $insert[page_title] = addslashes($data[faq_question]);
                $insert[page_keywords] = addslashes(DoKeywords($data[faq_answer_text]));
                MiniCache("cache/tags/faq-$id", "<?php \$insert[page_title] = \"$insert[page_title]\";\n\$insert[page_keywords] = \"$insert[page_keywords]\"; ?>");
            }
        }

        if ((preg_match("/review.php/i", $phps)) and ($id))
        {
            if (file_exists("cache/tags/review-$id.cah.php"))
            {
                require("cache/tags/review-$id.cah.php");
            }
            else
            {
                dbconnect();
                $query = DBQuery("SELECT * FROM esselbach_st_review WHERE review_id = '$id'");
                $data = mysql_fetch_array($query);
                $insert[page_title] = addslashes($data[review_title]);
                $insert[page_keywords] = addslashes(DoKeywords($data[review_text]));
                MiniCache("cache/tags/review-$id", "<?php \$insert[page_title] = \"$insert[page_title]\";\n\$insert[page_keywords] = \"$insert[page_keywords]\"; ?>");
            }
        }

        if ((preg_match("/thread.php/i", $phps)) and ($id))
        {
            if (file_exists("cache/tags/thread-$id.cah.php"))
            {
                require("cache/tags/thread-$id.cah.php");
            }
            else
            {
                dbconnect();
                $query = DBQuery("SELECT * FROM esselbach_st_forumsthreads WHERE thread_id = '$id'");
                $data = mysql_fetch_array($query);
                $insert[page_title] = addslashes($data[thread_topic]);
                $tforum = $data[thread_forum];

                $query = DBQuery("SELECT * FROM esselbach_st_forumsposts WHERE post_thread = '$id'");
                while ($data = mysql_fetch_array($query))
                {
                    $postings .= $data[post_text];
                }

                $result = DBQuery("SELECT * FROM esselbach_st_banwords");
                while ($banword = mysql_fetch_array($result)) $banwords[] = $banword[banword_word];

                for($b = 0; $b < count($banwords); $b++)
                {
                    $postings = preg_replace("/$banwords[$b]/", "", $postings);
                }

                $insert[page_keywords] = addslashes(DoKeywords($postings));

                $query = DBQuery("SELECT forum_status FROM esselbach_st_forums WHERE forum_id = '$tforum'");
                list($status) = mysql_fetch_row($query);

                if (!$status)
                {
                    $query = DBQuery("SELECT * FROM esselbach_st_websites WHERE website_id = '$configs[4]'");
                    $data = mysql_fetch_array($query);
                    $insert[page_title] = addslashes($data[website_dtitle]);
                    $insert[page_keywords] = addslashes($data[website_dkeywords]);
                }

                MiniCache("cache/tags/thread-$id", "<?php \$insert[page_title] = \"$insert[page_title]\";\n\$insert[page_keywords] = \"$insert[page_keywords]\"; ?>");
            }
        }

        if ((preg_match("/download.php/i", $phps)) and ($det))
        {
            if (file_exists("cache/tags/download-$det.cah.php"))
            {
                require("cache/tags/download-$det.cah.php");
            }
            else
            {
                dbconnect();
                $query = DBQuery("SELECT * FROM esselbach_st_downloads WHERE download_id = '$det'");
                $data = mysql_fetch_array($query);
                $insert[page_title] = addslashes($data[download_title]);
                $insert[page_keywords] = addslashes(DoKeywords($data[download_text]));
                MiniCache("cache/tags/download-$det", "<?php \$insert[page_title] = \"$insert[page_title]\";\n\$insert[page_keywords] = \"$insert[page_keywords]\"; ?>");
            }
        }

        if ((!preg_match("/story.php|faqshow.php|download.php|review.php|thread.php/i", $phps)) or (!$id))
        {
            if (file_exists("cache/tags/default.cah.php"))
            {
                require("cache/tags/default.cah.php");
            }
            else
            {
                dbconnect();
                $query = DBQuery("SELECT * FROM esselbach_st_websites WHERE website_id = '$configs[4]'");
                $data = mysql_fetch_array($query);
                $insert[page_title] = addslashes($data[website_dtitle]);
                $insert[page_keywords] = addslashes($data[website_dkeywords]);
                MiniCache("cache/tags/default", "<?php \$insert[page_title] = \"$insert[page_title]\";\n\$insert[page_keywords] = \"$insert[page_keywords]\"; ?>");
            }
        }

        $insert[page_title] = stripslashes($insert[page_title]);

        $website = $configs[4];
        $insert[site_name] = $configs[5];
        $insert[site_url] = $configs[6];

        if ($logcookie)
        {
            $ldata = addslashes(utf8_decode(base64_decode($logcookie)));
            $ldata = explode (":!:", $ldata);
            $insert[login_name] = stripslashes($ldata[0]);
            $login_file = base64_encode($insert[login_name]);

            if (file_exists("cache/pm/user-$login_file.cah.php"))
            {
                require("cache/pm/user-$login_file.cah.php");
            }

            if (file_exists("cache/pm/userlast-$login_file.cah.php"))
            {
                require("cache/pm/userlast-$login_file.cah.php");
            }

            if ($insert[login_time] < mktime())
            {
                dbconnect();

                $query = DBQuery("SELECT website_id, website_url FROM esselbach_st_websites");
                $websites_list = mysql_num_rows($query);
                while (list($website_id, $website_url) = mysql_fetch_row($query))
                {
                    $websites[$website_id] = $website_url;
                }

                if ($insert[login_time])
                {
                    $llast = $insert[login_time] - 3600;
                    $insert[login_last] = date("Y-m-d H:i:s", $llast);
                    $insert[login_current] = date("Y-m-d H:i:s", mktime());
                    $query = DBQuery("SELECT * FROM esselbach_st_stories WHERE story_website = '$website' AND story_hook = '0' AND story_time > ('$insert[login_last]') AND story_time < ('$insert[login_current]') OR story_website = '0' AND story_hook = '0' AND story_time > ('$insert[login_last]') AND story_time < ('$insert[login_current]')");
                    $insert[login_newscount] = mysql_num_rows($query);

                    if ($websites_list > 1)
                    {
                        $query2 = DBQuery("SELECT * FROM esselbach_st_stories WHERE story_hook = '0' AND story_time > ('$insert[login_last]') AND story_time < ('$insert[login_current]')");
                        $insert[login_newscount_all] = mysql_num_rows($query2);
                    }

                    if (file_exists("bbwrapper.php"))
                    {
                        $insert[login_threadcount] = BBLastTopics($llast);
                    }
                    else
                    {
                        $query = DBQuery("SELECT * FROM esselbach_st_forumsthreads WHERE thread_website = '$website' AND thread_endtime > ('$insert[login_last]') OR thread_website = '0' AND thread_endtime > ('$insert[login_last]')");
                        $insert[login_threadcount] = mysql_num_rows($query);
                        if ($websites_list > 1)
                        {
                            $query2 = DBQuery("SELECT * FROM esselbach_st_forumsthreads WHERE thread_endtime > ('$insert[login_last]')");
                            $insert[login_threadcount_all] = mysql_num_rows($query2);
                        }
                    }
                    if ($websites_list > 1)
                    {
                        MiniCache("cache/pm/userlast-$login_file", "<?php \$insert[login_last] = \"$insert[login_last]\";\n \$insert[login_newscount] = \"$insert[login_newscount]\";\n \$insert[login_newscount_all] = \"$insert[login_newscount_all]\";\n \$insert[login_threadcount] = \"$insert[login_threadcount]\";\n \$insert[login_threadcount_all] = \"$insert[login_threadcount_all]\"; ?>");
                    }
                    else
                    {
                        MiniCache("cache/pm/userlast-$login_file", "<?php \$insert[login_last] = \"$insert[login_last]\";\n \$insert[login_newscount] = \"$insert[login_newscount]\";\n \$insert[login_threadcount] = \"$insert[login_threadcount]\"; ?>");
                    }
                }

                if (file_exists("bbwrapper.php"))
                {
                    $insert[login_pms] = BBPMs($insert[login_name]);
                }
                else
                {
                    $query = DBQuery("SELECT * FROM esselbach_st_pms WHERE pm_touser = '$ldata[0]' AND pm_new = '1'");
                    $insert[login_pms] = mysql_num_rows($query);
                }
                $insert[login_time] = mktime() + 3600;
                MiniCache("cache/pm/user-$login_file", "<?php \$insert[login_pms] = \"$insert[login_pms]\";\n\$insert[login_time] = \"$insert[login_time]\"; ?>");
            }

            if (($insert[login_newscount_all]) or ($insert[login_threadcount_all]))
            {
                $insert[login_header] = GetTemplate("login_header_user_all");
            }
            else
            {
                $insert[login_header] = GetTemplate("login_header_user");
            }
        }
        else
        {
            $insert[login_header] = GetTemplate("login_header_anon");
        }

        if ($configs[21])
        {
            $current_time = time();
            $current_session = time() - 900;
            $ipaddress = GetIP();

            dbconnect();

            DBQuery("DELETE FROM esselbach_st_online WHERE online_ip='$ipaddress'");

            if ($ldata[0])
            {
                DBQuery("DELETE FROM esselbach_st_online WHERE online_user='$ldata[0]'");
            }

            DBQuery("INSERT INTO esselbach_st_online VALUES ('$configs[4]', '$current_time', '$ldata[0]', '$ipaddress')");
            DBQuery("DELETE FROM esselbach_st_online WHERE online_time < $current_session");
            $result = DBQuery("SELECT * FROM esselbach_st_online WHERE online_website = '$configs[4]'");
            $insert[site_onlineusers] = mysql_num_rows($result);
        }
        else
        {
            $insert[site_onlineusers] = "N/A";
        }

        echo GetTemplate("site_header");

        $cache = GetCache("news", "header_block");

        if (!$cache)
        {

            dbconnect();

            $result = DBQuery("SELECT * FROM esselbach_st_websites WHERE website_id = '$website'");
            $blocks = mysql_fetch_array($result);

            if ($blocks[website_blockrow1])
            {

                ($blocks[website_blockmode1] == 3) ? $blockline = 4 :
                 $blockline = 3;

                for($a = 1; $a < $blockline; $a++)
                {
                    if ($a == 1)
                    {
                        $var = $blocks[website_block11];
                        $var2 = $blocks[website_blocktitle11];
                        $var3 = $blocks[website_blockfile11];
                    }
                    if ($a == 2)
                    {
                        $var = $blocks[website_block12];
                        $var2 = $blocks[website_blocktitle12];
                        $var3 = $blocks[website_blockfile12];
                    }
                    if (($a == 3) and ($blocks[website_blockmode1] == 3))
                    {
                        $var = $blocks[website_block13];
                        $var2 = $blocks[website_blocktitle13];
                        $var3 = $blocks[website_blockfile13];
                    }

                    $insert[website_blocktitle] = $var2;
                    if ($a == 1)
                    {
                        ($blocks[website_blockmode1] == 3) ? $thisblock .= GetTemplate("main_block_header") :
                         $thisblock .= GetTemplate("main_block_buttom");
                    }
                    else
                    {
                        ($blocks[website_blockmode1] == 3) ? $thisblock .= GetTemplate("main_block_middle") :
                         $thisblock .= GetTemplate("main_block_buttom_middle");
                    }

                    if ($blocks[website_blockmode1] == 3)
                    {
                        $thisblock .= GetBlock($var, $var2, $var3, 35, 32, $website);
                    }
                    else
                    {
                        $thisblock .= GetBlock($var, $var2, $var3, 52, 49, $website);
                    }

                }
                $thisblock .= GetTemplate("main_block_footer");
            }

            if ($blocks[website_blockrow4])
            {

                ($blocks[website_blockmode4] == 3) ? $blockline = 4 :
                 $blockline = 3;

                for($a = 1; $a < $blockline; $a++)
                {
                    if ($a == 1)
                    {
                        $var = $blocks[website_block41];
                        $var2 = $blocks[website_blocktitle41];
                        $var3 = $blocks[website_blockfile41];
                    }
                    if ($a == 2)
                    {
                        $var = $blocks[website_block42];
                        $var2 = $blocks[website_blocktitle42];
                        $var3 = $blocks[website_blockfile42];
                    }
                    if (($a == 3) and ($blocks[website_blockmode4] == 3))
                    {
                        $var = $blocks[website_block43];
                        $var2 = $blocks[website_blocktitle43];
                        $var3 = $blocks[website_blockfile43];
                    }

                    $insert[website_blocktitle] = $var2;
                    if ($a == 1)
                    {
                        ($blocks[website_blockmode4] == 3) ? $thisblock .= GetTemplate("main_block_header") :
                         $thisblock .= GetTemplate("main_block_buttom");
                    }
                    else
                    {
                        ($blocks[website_blockmode4] == 3) ? $thisblock .= GetTemplate("main_block_middle") :
                         $thisblock .= GetTemplate("main_block_buttom_middle");
                    }

                    if ($blocks[website_blockmode4] == 3)
                    {
                        $thisblock .= GetBlock($var, $var2, $var3, 35, 32, $website);
                    }
                    else
                    {
                        $thisblock .= GetBlock($var, $var2, $var3, 52, 49, $website);
                    }

                }
                $thisblock .= GetTemplate("main_block_footer");
            }

            WriteCache("news", "header_block", $thisblock, MkTime()+3600);


        }
    }

    function FooterBlock ()
    {

        global $insert, $configs;
        $cache = GetCache("news", "footer_block");

        if (!$cache)
        {

            $website = $configs[4];

            dbconnect();

            $result = DBQuery("SELECT * FROM esselbach_st_websites WHERE website_id = '$website'");
            $blocks = mysql_fetch_array($result);

            if ($blocks[website_blockrow2])
            {

                ($blocks[website_blockmode2] == 3) ? $blockline = 4 :
                 $blockline = 3;

                for($a = 1; $a < $blockline; $a++)
                {
                    if ($a == 1)
                    {
                        $var = $blocks[website_block21];
                        $var2 = $blocks[website_blocktitle21];
                        $var3 = $blocks[website_blockfile21];
                    }
                    if ($a == 2)
                    {
                        $var = $blocks[website_block22];
                        $var2 = $blocks[website_blocktitle22];
                        $var3 = $blocks[website_blockfile22];
                    }
                    if (($a == 3) and ($blocks[website_blockmode3] == 3))
                    {
                        $var = $blocks[website_block23];
                        $var2 = $blocks[website_blocktitle23];
                        $var3 = $blocks[website_blockfile23];
                    }


                    $insert[website_blocktitle] = $var2;
                    if ($a == 1)
                    {
                        ($blocks[website_blockmode2] == 3) ? $thisblock .= GetTemplate("main_block_header") :
                         $thisblock .= GetTemplate("main_block_buttom");
                    }
                    else
                    {
                        ($blocks[website_blockmode2] == 3) ? $thisblock .= GetTemplate("main_block_middle") :
                         $thisblock .= GetTemplate("main_block_buttom_middle");
                    }

                    if ($blocks[website_blockmode2] == 3)
                    {
                        $thisblock .= GetBlock($var, $var2, $var3, 35, 32, $website);
                    }
                    else
                    {
                        $thisblock .= GetBlock($var, $var2, $var3, 52, 49, $website);
                    }

                }
                $thisblock .= GetTemplate("main_block_footer");
            }

            if ($blocks[website_blockrow3])
            {

                ($blocks[website_blockmode3] == 3) ? $blockline = 4 :
                 $blockline = 3;

                for($a = 1; $a < $blockline; $a++)
                {
                    if ($a == 1)
                    {
                        $var = $blocks[website_block31];
                        $var2 = $blocks[website_blocktitle31];
                        $var3 = $blocks[website_blockfile31];
                    }
                    if ($a == 2)
                    {
                        $var = $blocks[website_block32];
                        $var2 = $blocks[website_blocktitle32];
                        $var3 = $blocks[website_blockfile32];
                    }
                    if (($a == 3) and ($blocks[website_blockmode3] == 3))
                    {
                        $var = $blocks[website_block33];
                        $var2 = $blocks[website_blocktitle33];
                        $var3 = $blocks[website_blockfile33];
                    }

                    $insert[website_blocktitle] = $var2;
                    if ($a == 1)
                    {
                        ($blocks[website_blockmode3] == 3) ? $thisblock .= GetTemplate("main_block_header") :
                         $thisblock .= GetTemplate("main_block_buttom");
                    }
                    else
                    {
                        ($blocks[website_blockmode3] == 3) ? $thisblock .= GetTemplate("main_block_middle") :
                         $thisblock .= GetTemplate("main_block_buttom_middle");
                    }

                    if ($blocks[website_blockmode3] == 3)
                    {
                        $thisblock .= GetBlock($var, $var2, $var3, 35, 32, $website);
                    }
                    else
                    {
                        $thisblock .= GetBlock($var, $var2, $var3, 52, 49, $website);
                    }

                }
                $thisblock .= GetTemplate("main_block_footer");
            }

            WriteCache("news", "footer_block", $thisblock, MkTime()+3600);
        }

        $insert[site_name] = $configs[5];
        $insert[site_url] = $configs[6];

        if ($configs[14])
        {
            $insert[powered_by] = "";
            if ($configs[16])
            {
                $insert[powered_by] .= "<center>Copyright &copy; ".$configs[16]."</center>";
            }
            $insert[powered_by] .= "<center>Powered by <a href=\"http://www.contentteller.com\" target=\"_blank\">Esselbach Storyteller CMS</a></center>";

            if ($configs[15])
            {
                $insert[powered_by] .= "<center>Licensed to: ".$configs[15]."</center>";
            }
        }
        else
        {
            $insert[powered_by] = "<center><a href=\"http://www.contentteller.com\" title=\"This website is powered by Esselbach Storyteller CMS\" target=\"_blank\"><img src=\"images/poweredby.png\"></a></center>";
        }

        if ($configs[21])
        {
            $result = DBQuery("SELECT * FROM esselbach_st_online WHERE online_website = '$configs[4]'");
            $insert[site_onlineusers] = mysql_num_rows($result);
        }
        else
        {
            $insert[site_onlineusers] = "N/A";
        }

        echo GetTemplate("site_footer");
        exit;

    }

    function GetBlock($var, $var2, $var3, $var4, $var5, $website)
    {

        global $insert;

        ($var) ? $cat = "story_category = '$var' AND" :
         $cat = "";

        if ($var == 100)
        {
            if (file_exists("blocks/$var3"))
            {
                $blockdata = file("blocks/$var3");
                for($z = 0; $z < count($blockdata); $z++)
                {
                    $insert[story_blockline] = $blockdata[$z];
                    $thisblock .= GetTemplate("main_block_file");
                }
            }
        }
        elseif ($var == 110)
        {
            $result = DBQuery("SELECT * FROM esselbach_st_faq WHERE faq_website = '$website' OR faq_website = '0' ORDER BY faq_id DESC LIMIT 10");
            while ($insert = mysql_fetch_array($result))
            {
                (strlen($insert[faq_question]) > $var4) ? $insert[story_title] = substr($insert[faq_question], 0, $var5)."..." :
                 $insert[story_title] = $insert[faq_question];
                $insert[story_url] = "faq.php?id=$insert[faq_id]";
                $thisblock .= GetTemplate("main_block_list");
            }
        }
        elseif ($var == 120)
        {
            $result = DBQuery("SELECT * FROM esselbach_st_review WHERE review_website = '$website' AND review_hook = '0' AND review_page = '1' OR review_website = '0' AND review_hook = '0' AND review_page = '1' ORDER BY review_id DESC LIMIT 10");
            while ($insert = mysql_fetch_array($result))
            {
                (strlen($insert[review_title]) > $var4) ? $insert[story_title] = substr($insert[review_title], 0, $var5)."..." :
                 $insert[story_title] = $insert[review_title];
                $insert[story_url] = "review.php?id=$insert[review_id]";
                $thisblock .= GetTemplate("main_block_list");
            }
        }
        elseif ($var == 130)
        {
            $result = DBQuery("SELECT * FROM esselbach_st_downloads WHERE download_website = '$website' AND download_hook = '0' OR download_website = '0' AND download_hook = '0' ORDER BY download_id DESC LIMIT 10");
            while ($insert = mysql_fetch_array($result))
            {
                (strlen($insert[download_title]) > $var4) ? $insert[story_title] = substr($insert[download_title], 0, $var5)."..." :
                 $insert[story_title] = $insert[download_title];
                $insert[story_url] = "download.php?det=$insert[download_id]";
                $thisblock .= GetTemplate("main_block_list");
            }
        }
        elseif ($var == 131)
        {
            $result = DBQuery("SELECT * FROM esselbach_st_downloads WHERE download_website = '$website' AND download_hook = '0' OR download_website = '0' AND download_hook = '0' ORDER BY download_count DESC LIMIT 10");
            while ($insert = mysql_fetch_array($result))
            {
                (strlen($insert[download_title]) > $var4) ? $insert[story_title] = substr($insert[download_title], 0, $var5)."..." :
                 $insert[story_title] = $insert[download_title];
                $insert[story_url] = "download.php?det=$insert[download_id]";
                $thisblock .= GetTemplate("main_block_list");
            }
        }
        elseif ($var == 140)
        {
            $result = DBQuery("SELECT * FROM esselbach_st_plans p, esselbach_st_users u WHERE u.user_name = p.plan_user AND plan_website = '$website' OR u.user_name = p.plan_user AND plan_website = '0' ORDER BY plan_id DESC LIMIT 10");
            while ($insert = mysql_fetch_array($result))
            {
                $insert[plan_user] = $insert[plan_user]." (".$insert[plan_time].")";
                (strlen($insert[plan_user]) > $var4) ? $insert[story_title] = substr($insert[plan_user], 0, $var5)."..." :
                 $insert[story_title] = $insert[plan_user];
                $insert[story_url] = "plan.php?det=$insert[plan_id]";
                $thisblock .= GetTemplate("main_block_list");
            }
        }
        elseif ($var == 150)
        {
            $result = DBQuery("SELECT * FROM esselbach_st_forumsthreads t, esselbach_st_forums f WHERE t.thread_website = '$website' AND f.forum_status = '1' AND t.thread_forum = f.forum_id OR t.thread_website = '0' AND f.forum_status = '1' AND t.thread_forum = f.forum_id ORDER BY t.thread_endtime DESC LIMIT 10");
            while ($insert = mysql_fetch_array($result))
            {
                $insert[story_title] = htmlentities($insert[thread_topic]);
                if (strlen($insert[story_title]) > $var4)
                {
                    $insert[story_title] = substr($insert[story_title], 0, $var5)."...";
                }
                $insert[story_url] = "thread.php?id=$insert[thread_id]";
                $thisblock .= GetTemplate("main_block_list");
            }
        }
        elseif ($var == 151)
        {
            $result = DBQuery("SELECT * FROM esselbach_st_forumsthreads t, esselbach_st_forums f WHERE t.thread_website = '$website' AND f.forum_status = '1' AND t.thread_forum = f.forum_id OR t.thread_website = '0' AND f.forum_status = '1' AND t.thread_forum = f.forum_id ORDER BY t.thread_views DESC LIMIT 10");
            while ($insert = mysql_fetch_array($result))
            {
                $insert[story_title] = htmlentities($insert[thread_topic]);
                if (strlen($insert[story_title]) > $var4)
                {
                    $insert[story_title] = substr($insert[story_title], 0, $var5)."...";
                }
                $insert[story_url] = "thread.php?id=$insert[thread_id]";
                $thisblock .= GetTemplate("main_block_list");
            }
        }
        elseif ($var == 200)
        {
            if (file_exists("bbwrapper.php"))
            {
                $bbdata = BBGetTopics();
                for($t = 0; $t < count($bbdata); $t++)
                {
                    $datasplit = explode("||~||", $bbdata[$t]);
                    (strlen($datasplit[1]) > $var4) ? $insert[story_title] = substr($datasplit[1], 0, $var5)."..." :
                     $insert[story_title] = $datasplit[1];
                    $insert[story_url] = $datasplit[0];
                    $thisblock .= GetTemplate("main_block_list");
                }
                dbconnect();
            }
        }
        else
        {
            $currentdate = date("Y-m-d H:i:s", mktime());
            $result = DBQuery("SELECT * FROM esselbach_st_stories WHERE $cat story_website = '$website' AND story_hook = '0' AND story_time < ('$currentdate') OR $cat story_website = '0' AND story_hook = '0' AND story_time < ('$currentdate') ORDER BY story_time DESC LIMIT 10");
            while ($insert = mysql_fetch_array($result))
            {

                if (strlen($insert[story_title]) > $var4) $insert[story_title] = substr($insert[story_title], 0, $var5)."...";
                $insert[story_url] = "story.php?id=$insert[story_id]";
                $thisblock .= GetTemplate("main_block_list");
            }
        }

        return $thisblock;

    }

    function GetIP()
    {

        if (phpversion() >= "4.1.0")
        {
            ($_SERVER["HTTP_X_FORWARDED_FOR"]) ? $var = $_SERVER["HTTP_X_FORWARDED_FOR"] :
             $var = $_SERVER["REMOTE_ADDR"];
        }
        else
        {
            (getenv("HTTP_X_FORWARDED_FOR")) ? $var = getenv("HTTP_X_FORWARDED_FOR") :
             $var = getenv("REMOTE_ADDR");
        }

        $var = addslashes( utf8_decode( $var ) );
        return $var;
    }

    function CryptMe($var)
    {
        if (phpversion() >= "4.3.0")
        {
            $var = sha1($var);
        }
        else
        {
            $var = md5($var);
        }

        return $var;
    }

    function DoAds ($var)
    {
        dbconnect();

        $query = DBQuery("SELECT * FROM esselbach_st_textads");
        while ($db = mysql_fetch_array($query))
        {
            $var = str_replace(" ".$db[ads_title], " <acronym title=\"$db[ads_text]\"><a href=\"ads.php?id=".base64_encode($db[ads_id])."\" target=\"_blank\">$db[ads_title]</a></acronym>", $var);
        }
        return $var;

    }

    function GetMessage ()
    {
    	global $utitle, $ulink;
        if (file_exists("../cache/pm/announcement.cah.php"))
        {
            require("../cache/pm/announcement.cah.php");
        }

        if ($insert[login_time] < mktime())
        {
			if( function_exists( "curl_init" ) )
			{
				$feed = curl_init( base64_decode("aHR0cDovL3d3dy5jb250ZW50dGVsbGVyLmNvbS91cGRhdGVzLnBocD9wcm9kdWN0PWV2YWx1YXRpb24mbGFuZz1lbg==") );

				curl_setopt( $feed, CURLOPT_RETURNTRANSFER, 1 );
				curl_setopt( $feed, CURLOPT_CONNECTTIMEOUT, 5 );
				curl_setopt( $feed, CURLOPT_USERAGENT, "Esselbach Storyteller CMS" );
				$data = curl_exec( $feed );
				curl_close( $feed );
			}
			else
			{
				$feed = @fopen( base64_decode("aHR0cDovL3d3dy5jb250ZW50dGVsbGVyLmNvbS91cGRhdGVzLnBocD9wcm9kdWN0PWV2YWx1YXRpb24mbGFuZz1lbg=="), "r" );
				$data = fread( $feed, 4096 );
				fclose( $feed );
			}

			$xml = xml_parser_create( "ISO-8859-1" );
			xml_set_element_handler( $xml, "rsslitestart", "rssliteend" );
			xml_set_character_data_handler( $xml, "rssliteparse" );
			$success = xml_parse( $xml, $data );
			xml_parser_free( $xml );

			$insert[login_message] = "<b>Updates:</b><br />";

			for ($u = 0; $u < 3; $u++)
			{
				$insert[login_message] .= "&middot; <a href=\\\"" . $ulink[$u] . "\\\" onclick=\\\"window.open(this.href);return false;\\\">" . $utitle[$u] . "</a><br />";
			}

            $insert[login_time] = mktime() + 144000;
            MiniCache("../cache/pm/announcement", "<?php \$insert[login_message] = \"$insert[login_message]\";\n\$insert[login_time] = \"$insert[login_time]\"; ?>");
            $insert[login_message] = stripslashes( $insert[login_message] );
        }

        return $insert[login_message];
    }

    function SuperCount ($var, $var2)
    {
        $var = str_replace("/","Un",$var);
        $var = str_replace("[","Lf",$var);
        $var = str_replace("]","Rg",$var);
        $var2 = str_replace("/","Un",$var2);
        $var2 = str_replace("[","Lf",$var2);
        $var2 = str_replace("]","Rg",$var2);
        $myarray = preg_split("/[\s,]+/",$var2);
        $found = 0;
        for($i = 0; $i < count($myarray); $i++)
        {
            if (preg_match("/$var/i",$myarray[$i]))
            {
                $found++;
            }
        }
        return $found;
    }

    function GetLoad()
    {

        $buffer = "0 0 0";

        if (file_exists("/proc/loadavg"))
        {
            $f = fopen("/proc/loadavg","r");

            if (!feof($f))
            {
                $buffer = fgets($f, 1024);
            }

           fclose($f);
           $load = explode(" ",$buffer);

        }

        return $load;
    }

    function GetCPUInfo()
    {

        $cpus = 0;
        $processor = "Unknown processor";

        if (file_exists("/proc/cpuinfo"))
        {
            $cpu = file("/proc/cpuinfo");

            foreach ($cpu as $line)
            {
                if (preg_match("/processor/i", $line))
                {
                    $cpus++;
                }
                if (preg_match("/model name/i", $line))
                {
                    $procline = explode(":",$line);
                    $processor = $procline[1];
                }
            }
        }
        if ($cpus == 3) $cpus = 2;

        $cpuinfo = "$cpus|$processor";
        return $cpuinfo;
    }

    function MailHeader($var, $var2, $var3, $var4)
    {

        $headers = "From: ".$var." <".$var2.">\r \n";
        $headers .= "To: ".$var3." <".$var4.">\r \n";
        $headers .= "Reply-To: ".$var." <$var2>\r \n";
        $headers .= "MIME-Version: 1.0\n";
        $headers .= "Content-type: text/plain; charset=iso-8859-1\n";
        $headers .= "X-Priority: 1\n";
        $headers .= "X-MSMail-Priority: High\n";
        $headers .= "X-Mailer: Esselbach Storyteller CMS";

        return $headers;
    }

	function rsslitestart( $parser, $name, $attrs )
	{
		global $item, $tag, $title, $link;

		if( $item )
		{
			$tag = $name;
		}

		if( $name == "ITEM" )
		{
			$item = 1;
		}
	}

	function rssliteparse( $parser, $data )
	{
		global $item, $tag, $title, $link;

		if( $item )
		{
			if( $tag == "TITLE" )
			{
				$title .= $data;
			}
			elseif( $tag == "LINK" )
			{
				$link .= $data;
			}
		}
	}

	function rssliteend( $parser, $name )
	{
		global $item, $tag, $title, $link, $utitle, $ulink;

		if( $name == "ITEM" )
		{
			$utitle[ ] = htmlspecialchars( trim( $title ) );
			$ulink[ ] = htmlspecialchars( trim( $link ) );
			$title = "";
			$link = "";
			$item = 0;
		}
	}

?>